{$M $F000, 0, $20000}
{$I+,S+,R+,Q+}

const MAX_EL=250;
      MAX_EQ=500;
      INFTY=$3FFFFFFF;

type El_Set=set of 1..MAX_EL;
     TEq=record
           time:integer;
           left,right:El_Set;
         end;
     TReactOut=record
                 eq_:integer;
                 tim_:longint
               end;

var fv:text;
    i,j,N_El,N_Eq,num_unused:integer;
    EQs:array[1..MAX_EQ] of TEq;
{while spreading - number of the reaction which gave the elem;
 while backing - positive number means we may need push reaction to list,
                 negative - it's already pushed}
    got_time:array[1..MAX_EL] of longint;
{time when the elem got}
    N_pres:integer;
    e,goal_el:integer;
    need_reacts:array[0..MAX_EQ] of TReactOut;
    num_reacts:integer;

    goal_time:longint;
    present:El_Set;
    Eq_Out:array[1..MAX_EQ] of boolean;

procedure read_eq(var fv:text; var eq:TEq);
var i,num,el:integer;
Begin
  readln(fv,eq.time);
  read(fv,num);
  for i:=1 to num do begin
    read(fv,el);
    eq.left:=eq.left+[el];
  end;
  readln(fv);
  read(fv,num);
  for i:=1 to num do begin
    read(fv,el);
    eq.right:=eq.right+[el];
  end;
  readln(fv);
End;

function GetElem(elem:byte; cannot_use:El_Set):longint;
var eq:integer;
    el:byte;
    t_el,t_eq,t_goal:longint;

{t_el -- time to get curr. element of written in left side of equation;
t_eq = max(t_el) -- time to get _all_ elems in left side of equation;
t_goal = min(t_eq) -- time to get goal elem using any possible equation}

Begin
  if elem in present then begin
    GetElem:=0;
    exit
  end;
  t_goal:=INFTY;
  for eq:=1 to N_Eq do
{'⮢   箢, i      ⥪i;
  类  㯭 i    I  室
 ᠬ 箢, ய᪠}
    if elem in eqs[eq].right then
      if cannot_use*eqs[eq].left = [] then begin
        t_eq:=0;
        t_el:=0;
        for el:=1 to N_el do
          if el in eqs[eq].left then begin
            t_el:=GetElem(el,cannot_use+[el]);
            if t_el>t_eq then begin
              t_eq:=t_el;
              if t_el>=INFTY then break;
            end;
          end;
        if t_eq+eqs[eq].time<t_goal then begin
          t_goal:=t_eq+eqs[eq].time;
          if t_goal<got_time[elem] then begin
            got_time[elem]:=t_goal;
          end;
        end;
      end;
  GetElem:=t_goal;
End;

BEGIN
  assign(fv,'alchemy.dat'); reset(fv);
  readln(fv,N_El,N_Eq,N_pres,goal_el);
  for i:=1 to N_El do begin
    got_time[i]:=INFTY;
  end;
  present:=[];
  for e:=1 to N_pres do begin
    present:=present+[e];
    got_time[e]:=0;
  end;
  num_unused:=N_eq;
  for i:=1 to N_Eq do begin
    read_eq(fv,eqs[i]);
  end;
  close(fv);
(*
initialization complete, starting processing
*)

  goal_time:=GetElem(goal_el,[goal_el]);

(*
main processing complete, starting outputting (and restoring schedule)
*)
  assign(fv,'alchemy.sol'); rewrite(fv);

  if goal_time>=INFTY then
    writeln(fv,'-1')
  else begin
    writeln(fv,goal_time);
  end;
  close(fv);
END.