{
  Olympiad:  Ukrainian Olympiad in Informatics 2003
  Problem:   TRIANGLE
  Author:    Ilya Porublyov
}

var fv:text;
    x,y,t,nsd_:longint;
    tot,tot_:longint;
    P:longint;


function NSD(x,y:longint):longint;
Begin
  while (x>0) and (y>0) do
    if x>y then x:=x mod y
           else y:=y mod x;
  if x>0 then NSD:=x
         else NSD:=y
End;                                            

function Formula2(x,y:longint):longint;
var mul1,mul2,prod,subtr,res_,res:longint;
Begin
  mul1:=x mod (2*P);
  mul2:=y mod (2*P);
  prod:=(mul1*mul2) mod (2*P);
  subtr:=(2*P+(x mod (2*P))+(y mod (2*P))-1) mod (2*P);
  res_:=(prod-subtr) div 2;
  res:=(2*P+res_) mod P;
  Formula2:=res;


  {Formula2:=(2*P+(((x mod (2*P))*(y mod (2*P))) mod (2*P)-(x+y-1) mod (2*P)) div 2) mod P;}
End;


BEGIN
  assign(fv,'triangle.dat'); reset(fv);
  readln(fv,x,y,P);
  close(fv);

  nsd_:=NSD(x,y);
  if nsd_>1 then begin
    Tot:=Formula2(x div nsd_,y div nsd_);
    tot_:=((nsd_ mod (2*P))*((nsd_-1) mod (2*P)) div 2) mod P;
    tot_:=(tot_*(((x div nsd_) mod P)*((y div nsd_) mod P) mod P)) mod P;
    Tot:=(Tot*(nsd_ mod P) +tot_) mod P;
  end else
    Tot:=Formula2(x,y);


  assign(fv,'triangle.sol'); rewrite(fv);
  WriteLn(fv,(P-Tot) mod P);
  close(fv);
END.
