{
  Olympiad:  Ukrainian Olympiad in Informatics 2003
  Problem:   CHAIN
  Author:    Andrew Statyuk
}

const
  maxN=10000;
  Inf=maxN-1;
type
  list = array[1..maxN] of word;

  procedure heapsort(var a: list; N: word);
  var
    i:word;

    procedure Xch(i,j:word);
    var
      temp:word;
    begin
      temp:=a[i];
      a[i]:=a[j];
      a[j]:=temp;
    end;

    procedure Heapify(what:word);
    var
      max:word;
    begin
      while what*2<=N do
      begin
        max:=what;
        if a[what*2]>a[max] then
          max:=what*2;
        if (what*2+1<=N)AND
          (a[what*2+1]>a[max]) then
          max:=what*2+1;
        if max=what then
          what:=n
        else
        begin
          Xch(what,max);
          what:=max;
        end;
      end;
    end;

  begin
    for i:=N div 2 downto 1 do
      Heapify(i);
    i:=N;
    while N>1 do
    begin
      Xch(1,N);
      Dec(N);
      Heapify(1);
    end;
    N:=i;
  end;

var
  kuski:list;
  s,N,M,i:word;
  fi,fo:text;
  temp:longint;

begin
  assign(fi,'chain.dat');
  assign(fo,'chain.sol');
  reset(fi);
  rewrite(fo);

  readln(fi,N);
  for i:=1 to N do
  begin
    read(fi,temp);
    if temp>=Inf then
      kuski[i]:=Inf
    else
      kuski[i]:=temp;
  end;
  heapsort(kuski,N);

  s:=0;
  i:=1;
  M:=0;
  while s+kuski[i]<N-i do
  begin
    Inc(M);
    s:=s+kuski[i];

    Inc(i);
  end;

  writeln(fo,N-M-1);

  close(fi);
  close(fo);
end.